ubiquity crashed with AttributeError in keyboard_variant_timeout(): 'NoneType' object has no attribute 'apply_keyboard'

Bug #944614 reported by zhai on 2012-03-02
20
This bug affects 2 people
Affects Status Importance Assigned to Milestone
ubiquity (Ubuntu)
High
Stéphane Graber
Precise
High
Unassigned

Bug Description

=== Rational ===
Ubiquity crashes when a user quickly moves forward or back from the keyboard selection page. That's due to a gobject timeout still triggering even after the whole page has been destroyed.

=== Test case ===
1) Do a standard Ubuntu install, go through the page until the keyboard selection page
2) Quickly move through the countries using the DOWN arrow key
3) At any random point, stop and IMMEDIATELY (within the next second) click on BACK
4) Without the fix, ubiquity would crash at that point

=== Regression potential ===
None, we've had that patch in ubiquity for a while now and haven't seen any bug related to that part of the code show up since.

--- original bug report ---
aanztaimaf

ProblemType: Crash
DistroRelease: Ubuntu 12.04
Package: ubiquity 2.9.23
ProcVersionSignature: Ubuntu 3.2.0-17.27-generic 3.2.6
Uname: Linux 3.2.0-17-generic x86_64
ApportVersion: 1.93-0ubuntu2
Architecture: amd64
CasperVersion: 1.305
Date: Fri Mar 2 23:49:57 2012
ExecutablePath: /usr/lib/ubiquity/bin/ubiquity
InstallCmdLine: BOOT_IMAGE=/ubuntu/install/boot/vmlinuz debian-installer/custom-installation=/ubuntu/install/custom-installation iso-scan/filename=/ubuntu/install/installation.iso automatic-ubiquity noprompt quiet splash boot=casper ro debian-installer/locale=zh_CN.UTF-8 keyboard-configuration/layoutcode=us keyboard-configuration/variantcode= -- rootflags=sync
InterpreterPath: /usr/bin/python2.7
LiveMediaBuild: Ubuntu 12.04 LTS "Precise Pangolin" - Beta amd64 (20120301)
ProcCmdline: /usr/bin/python /usr/lib/ubiquity/bin/ubiquity --automatic --only
ProcEnviron: Error: [Errno 13] 权限不够: '/proc/4733/environ'
PythonArgs: ['/usr/lib/ubiquity/bin/ubiquity', '--automatic', '--only']
SourcePackage: ubiquity
Title: ubiquity crashed with AttributeError in keyboard_variant_timeout(): 'NoneType' object has no attribute 'apply_keyboard'
Traceback:
 Traceback (most recent call last):
   File "/usr/lib/ubiquity/plugins/ubi-console-setup.py", line 130, in keyboard_variant_timeout
     self.controller.dbfilter.apply_keyboard(layout, variant)
 AttributeError: 'NoneType' object has no attribute 'apply_keyboard'
UpgradeStatus: No upgrade log present (probably fresh install)
UserGroups:

Related branches

zhai (apple7086926) wrote :
zhai (apple7086926) wrote :

good

tags: removed: need-duplicate-check
Tyler Hicks (tyhicks) on 2012-03-02
security vulnerability: yes → no
security vulnerability: yes → no
visibility: private → public
visibility: private → public
Stéphane Graber (stgraber) wrote :

I have a tentative fix for this one, waiting for confirmation from someone else affected by the bug.

Changed in ubiquity (Ubuntu):
status: New → Triaged
importance: Undecided → High
assignee: nobody → Stéphane Graber (stgraber)
Changed in ubiquity (Ubuntu):
status: Triaged → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubiquity - 2.9.24

---------------
ubiquity (2.9.24) precise; urgency=low

  * webcam:
    - image-capture-encoder is deprecated, just drop it for now
    - gst_caps_new_simple needs to use a supported width/height,
      going with 640x480 as it seems standard for most webcams.
      (LP: #942030)
  * ubi-console-setup: On automatic install, don't wait 600ms or
    dbfilter will be None by the time the timer reaches 0 (LP: #944614)
  * debian/control: Add an explicit dependency on realpath to prevent
    check-missing-firmware from crashing. In d-i, realpath is provided
    by busybox.
 -- Stephane Graber <email address hidden> Fri, 02 Mar 2012 17:37:36 -0500

Changed in ubiquity (Ubuntu):
status: Fix Committed → Fix Released
zhai (apple7086926) wrote :

anzhuanga

Changed in ubiquity (Ubuntu):
assignee: Stéphane Graber (stgraber) → nobody
Changed in ubiquity (Ubuntu):
assignee: nobody → Stéphane Graber (stgraber)
don11995 (don11995) on 2012-03-04
Changed in ubiquity (Ubuntu):
assignee: Stéphane Graber (stgraber) → don11995 (don11995)
Stéphane Graber (stgraber) wrote :

Please stop messing with this bug report.

Thanks

Changed in ubiquity (Ubuntu):
assignee: don11995 (don11995) → Stéphane Graber (stgraber)
Changed in ubiquity (Ubuntu):
assignee: Stéphane Graber (stgraber) → someshwara ravi (soma006)
Changed in ubiquity (Ubuntu):
assignee: someshwara ravi (soma006) → Stéphane Graber (stgraber)
Daryl Sweat (curnel-d) wrote :

Fix released or not? Installed daily build, and had this error on first boot up.

Hendrymohan (hendry-66) on 2012-04-03
Changed in ubiquity (Ubuntu):
assignee: Stéphane Graber (stgraber) → Hendrymohan (hendry-66)
Changed in ubiquity (Ubuntu):
assignee: Hendrymohan (hendry-66) → Stéphane Graber (stgraber)
Changed in ubiquity (Ubuntu):
assignee: Stéphane Graber (stgraber) → Troy Grounds (lcplgrounds)
Changed in ubiquity (Ubuntu):
assignee: Troy Grounds (lcplgrounds) → Stéphane Graber (stgraber)
Tim Chen (timchen119) wrote :

This could still reproduced by 12.10 installer ,
step to reproduce:
1. install from 12.10 installation disk
2. At "Where are you?" page press continue.
3. At "Keyboard layout" page press continue.
4. At "Who are you?" page , quick press back twice.
5. ubiquity crashed.

Failed rate: 3/3, 100%

Dimitri John Ledkov (xnox) wrote :

Stephane, was this refixed or not? Can you please check and either commit fixes for raring and/or precise and/or close the bug and associated merge proposals.

Changed in ubiquity (Ubuntu):
status: Fix Released → Triaged
Stéphane Graber (stgraber) wrote :

I commited a fix for this to Ubiquity trunk.

This isn't based on any of the patches that have been proposed so far but instead does the "right" thing which is to cancel all timeouts when moving away from the console-setup page.

http://paste.ubuntu.com/5577302/

Changed in ubiquity (Ubuntu):
status: Triaged → Fix Committed
Changed in ubiquity (Ubuntu Precise):
importance: Undecided → High
status: New → Triaged
Stéphane Graber (stgraber) wrote :

Copying the fix to the precise branch.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubiquity - 2.13.13

---------------
ubiquity (2.13.13) raring; urgency=low

  [ Dmitrijs Ledkovs ]
  * Bump Standards version and override some lintian tags (ubiquity is
    weird).
  * Override expander style, which is hardcoded in light-themes to a
    light color. (LP: #1100922)
  * Consolidate CssProvider and add make minimal progress bar width 10px,
    in preparation for dot-progress of all steps.
  * Fix colour unit test, the green is no longer what it used to be...
  * Switch to "NotShowIn=KDE" for ubiquity-gtk desktop files, as most !kde
    desktop environments use gtk frontend.
  * Show progress dots for plugin pages and show progress bar only during
    slideshow.

  [ Colin Watson ]
  * Decode the output of apt_pkg.size_to_str() if necessary when
    substituting it into Unicode strings (LP: #877756, #1132918).
  * Update translations from Launchpad.

  [ Aurélien Gâteau ]
  * Turns the Ubiquity KDE window into a regular window and rework
    the layout of widgets to provide more space to the main content.
    The labels on the left now wrap to the next line if they are too long,
    ensuring they are never truncated.
  * KDE: Improve the layout of Prepare step
  * KDE: fix integration of the webview responsible for showing the slideshow
  * KDE: fix various issues with right-to-left languages

  [ Julien Lavergne ]
  * Use feh to draw the wallpaper on Lubuntu when using ubiquity-dm.

  [ Ma Jun (Kylin Team) ]
  * Fix referencing variable before assignment (LP: #945027)

  [ Kobe Lee ]
  * Show OS column in manual partitioning page. (LP: #1100694)

  [ Stéphane Graber ]
  * Fix crash in ubi-console-setup when quickly moving back and worth between
    pages. (LP: #944614)

  [ Jonathan Riddell ]
  * Add back compositing to kwin on live CD (in ubiquity-dm), whatever was wrong
    in 2008 should be fixed now and its making us look ugly
 -- Dmitrijs Ledkovs <email address hidden> Thu, 07 Mar 2013 19:53:52 +0000

Changed in ubiquity (Ubuntu):
status: Fix Committed → Fix Released
Steve Langasek (vorlon) wrote :

Stéphane, could we please get a clearly defined test case for how to verify this bugfix?

Changed in ubiquity (Ubuntu Precise):
status: Triaged → Incomplete
Stéphane Graber (stgraber) wrote :

Oops, I forgot we cherry-picked that one into the precise branch of ubiquity. SRU headers added.

description: updated
Changed in ubiquity (Ubuntu Precise):
status: Incomplete → In Progress

Hello zhai, or anyone else affected,

Accepted ubiquity into precise-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/ubiquity/2.10.25 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in ubiquity (Ubuntu Precise):
status: In Progress → Fix Committed
tags: added: verification-needed
Stéphane Graber (stgraber) wrote :

Works fine here.

tags: added: verification-done
removed: verification-needed

The verification of this Stable Release Update has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regresssions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubiquity - 2.10.25

---------------
ubiquity (2.10.25) precise; urgency=low

  [ Colin Watson ]
  * KDE frontend:
    - Set default QString encoding to UTF-8 (LP: #1057485).
  * Make ubiquity-frontend-debconf Architecture: any rather than all; the
    .bgf font format is architecture-dependent (LP: #1180880).
  * Automatic update of included source packages: partman-basicfilesystems
    71ubuntu3.1, partman-efi 25ubuntu1.1.

  [ Ma Jun (Kylin Team) ]
  * Fix referencing variable before assignment (LP: #945027)

  [ Stéphane Graber ]
  * Fix crash in ubi-console-setup when quickly moving back and forth between
    pages. (LP: #944614)
 -- Colin Watson <email address hidden> Fri, 17 May 2013 15:08:59 +0100

Changed in ubiquity (Ubuntu Precise):
status: Fix Committed → Fix Released
tags: added: eoan
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers